float phase = 0.0;
float phase_per_frame = 0.06;

float amplitude = 1.0;
float frequency = 98.0;
float freq_scale = 0.0004;

void setup() {
  size(640, 360);
  frameRate(180);
}

void draw() {
  background(150);
  fill(20);
  noStroke();
  rect(5, height/2, width-10, height/2-5);
  
  noFill();
  stroke( 0, 255, 0, 100 );
  strokeWeight( 0.5 );
  for( int y = height / 2 + 10; y < height - 10; y += 50 ) {
    line( 5, y, width-5, y );
  }
  for( int x = 10; x < width - 10; x += 50 ) {
    line( x, height/2, x, height-5 );
  }
  
  renderWave();
}

void renderWave() {
  stroke( 0, 255, 0 );
  strokeWeight( 2.0 );
  noFill();
  
  phase += phase_per_frame;
  
  beginShape();
  for( int x = 0; x < width; ++x ) {
    float th = x * frequency * freq_scale + phase;
    float cen = 0.75 * height;
    float max_height = amplitude * 0.2 * height;
    
    vertex( x, 
      map( sin( th ), -1, 1, cen - max_height, cen + max_height ) );
  }
  endShape();
}
